/**********************************

	Copy all the internal functions to a shared library's 
	function table
	
**********************************/

#include <burger.h>
#include <Processes.h>
#include <Gestalt.h>
#include <setjmp.h>
#include <fp.h>
#include "mac_export.h"
#include "qcommon.h"
#include "macfuncs.h"
#include <ctype.h>

#undef tolower
#undef isdigit
#undef Alloc
#undef AllocClear
#undef Free
#undef setjmp

#if CALL_NOT_IN_CARBON || defined(__MSL__)
#define setjmp __setjmp
#else
#define setjmp __lib_Glue_setjmp
#endif

void Mac_InitMacExport(macimport_t *Output)
{
	Output->import_version = MAC_IMPORT_VERSION;
	Output->Mac_fopenx = QuakeOpenAFile;
	Output->Sys_Mkdir = Sys_Mkdir;
	Output->Sys_Milliseconds = Sys_Milliseconds;
	Output->Mac_A2S = Mac_AddressToSymbol;
	Output->Mac_S2A = Mac_SymbolToAddress;
	
	Output->Alloc = Alloc;
	Output->AllocClear = AllocClear;
	Output->Free = Free;
	Output->DebugDeallocAPointer = DebugDeallocAPointer;
	Output->StreamHandleSaveTextFile = StreamHandleSaveTextFile;
	Output->StreamHandlePutByte = StreamHandlePutByte;
	Output->StreamHandlePutStringNoZero = StreamHandlePutStringNoZero;
	Output->StreamHandleGetString2 = StreamHandleGetString2;
	Output->StreamHandleInitGetPtr = StreamHandleInitGetPtr;
	Output->StreamHandleGetShort = StreamHandleGetShort;
	Output->AsciiToLongWord2 = Burger::AsciiToInteger;
	Output->StrSetFileExtension = Burger::SetFileExtension;
	Output->FastMemCpy = FastMemCpy;
	Output->FastMemSet = FastMemSet;
//	Output->BRStringAppendBRString = BRStringAppendBRString;
//	Output->BRStringInitBRString = BRStringInitBRString;
//	Output->BRStringInitPChar = BRStringInitPChar;
	Output->DebugAllocAPointerClear = DebugAllocAPointerClear;
	Output->LockAHandle = LockAHandle;
	Output->UnlockAHandle = UnlockAHandle;
//	Output->BRStringNeBString = BRStringNeBString;
	Output->StreamHandleInitPut = StreamHandleInitPut;
//	Output->BRStringInitPCharRange = BRStringInitPCharRange;
//	Output->BRStringEqPChar = BRStringEqPChar;
//	Output->BRStringEqBString = BRStringEqBString;
	Output->StreamHandleGetFloat = StreamHandleGetFloat;
	Output->LinkedListInit = LinkedListInit;
	Output->LinkedListDestroy = LinkedListDestroy;
	Output->DebugAllocAPointer = DebugAllocAPointer;
	Output->StreamHandleDestroy = StreamHandleDestroy;
	Output->StreamHandleEndSave = StreamHandleEndSave;
	Output->StreamHandleSetMark = StreamHandleSetMark;
	Output->StreamHandleGetMem = StreamHandleGetMem;
	Output->StreamHandlePutMem = StreamHandlePutMem;
	Output->StreamHandleGetLong = StreamHandleGetLong;
	Output->StreamHandlePutLong = StreamHandlePutLong;
	Output->FastStrLen = Burger::StringLength;
//	Output->BRStringCopyBRString = BRStringCopyBRString;
//	Output->BRStringAppendPChar = BRStringAppendPChar;
//	Output->BRStringCopyPChar = BRStringCopyPChar;
	Output->LinkedListGetEntryData = LinkedListGetEntryData;
	Output->XLinkedListAddNewEntryStringEnd = LinkedListAddNewEntryStringEnd;
	Output->XStrCopy = Burger::StringDuplicate;
	Output->XDebugString = Debug::String;		
	Output->FastStrncmp = FastStrncmp;
	Output->rand = rand;
	Output->fclose = fclose;
	Output->fwrite = fwrite;
	
	Output->acos = acos;
	Output->sqrt = sqrt;
	Output->floor = floor;
	Output->cos = cos;
	Output->sin = sin;
	Output->asin = asin;
	Output->atan2 = atan2;
	Output->fmod = fmod;
	
	Output->dec2num = dec2num;
	Output->num2dec = num2dec;

	Output->ExitToShell = ExitToShell;
	Output->Gestalt = Gestalt;
}

#if TARGET_API_MAC_CARBON
#ifdef __cplusplus
extern "C" {
int rand(void);
}
#endif

Burger::Random g_RndMain;

int std::rand(void)
{
	return g_RndMain.Get(32768);
}
#endif
