#include "macfuncs.h"
#include <stdlib.h>
#include <Movies.h>
#include "mac_isp.h"
#include "ModelessDLOG.h"
#include "qcommon.h"

#if defined(__GAMERANGER__)
#include <GameRanger.h>
#include "Mac_Version.h"
#endif

// ------------------------------------------------------------
#if defined(__GAMERANGER__)

static void InitGameRanger(void)
{
	if (GRCheckFileForCmd()) {
		GRGetWaitingCmd();
		
		if (GRGetPropertyStr('CmdL')) {
			BypassPlug = TRUE;			/* Don't show the intro */
			Mac_SetCommandLine(GRGetPropertyStr('CmdL'));
		}
	}
}
#endif

// ------------------------------------------------------------
void MacOSStartup(void)
{
	Word i;
	char dstr[128];
	unsigned long rawdate;
	DateTimeRec thedate;	
	
// must add more error checking in here later on...

	MacOSInitTools();		/* MacOS standard init */
	InitMemory();			/* Init the burgerlib memory manager */
	Burger::FileManager::DefaultPrefixes();	/* Init the prefix manager */

	// Flush out mouse and keyboard events
	FlushEvents(mDownMask | keyDownMask | autoKeyMask, 0);

	if (TempMaxMem(NULL) < (1024*1024 * 5)) {
		DoMacFatalDialog("Mac OS has less than 5 meg free RAM, decrease Sin preferred RAM size using Finder Get Info or increase VM settings");
		exit(0);
	}

	GetDateTime(&rawdate);
	SecondsToDate(rawdate,&thedate);
	sprintf(dstr,"MacOSStartup %d:%d:%d on %d/%d/%d ############ \n",
			thedate.hour,thedate.minute,thedate.second,
			thedate.day,thedate.month,thedate.year);
	MDebugXString(dstr);	// debug, dump starting time
	

	Mac_MenuBarInit();

	// By default the system doesn't give us keyup events, and we need them for Q2...
	SetEventMask(everyEvent);

#if defined(__GAMERANGER__)
	InitGameRanger();
#endif
	Mac_InitAppleEventHandler();
	NetInit();				// if doesn't return kOTNoError, Open Transport is not installed
	EnterMovies();

	Mac_WNE(TRUE);			// call WaitNextEvent, TRUE=starting up wait for any Apple Events

	//ValidateSystem();

	InitTheBurger();

	/* Setup InputSprocket (the great satan) */
	if (Input_Available()) {
		Input_Initialize();		/* will set flags if successful */
	}
	
	i = 20000/64;
	do {
		MoreMasters();		/* Make some more handles */
	} while (--i);

	HideCursor();
}

void MacOSShutdown(void)
{
	MDebugXString("MacOSShutdown ############################\n");
	NET_Shutdown();
	ShowCursor();
	ExitMovies();
	NetShutdown();
	Mac_KillAppleEventHandler();
	Mac_KillEvents();
}
