#include "Mac_Snd.h"
#include <Sound.h>

short s_mixedSamples[MAX_MIXED_SAMPLES];
int s_chunkCount;		// number of chunks submitted
int s_samplerate;
static SndChannel *s_sndChan;
static ExtSoundHeader s_sndHeader;
static SndCallBackUPP SndCodePtr;

/*
===============
S_Callback
===============
*/
static void pascal S_Callback( SndChannel *sc, SndCommand *cmd )
{
	SndCommand mySndCmd;
	int offset;
	
	offset = ( s_chunkCount * SUBMISSION_CHUNK ) & (MAX_MIXED_SAMPLES-1);
	
	// que up another sound buffer
	s_sndHeader.samplePtr = (char *)(s_mixedSamples + offset);
	s_sndHeader.numChannels = 2;

	if (s_samplerate == 44100) {
		s_sndHeader.sampleRate = rate44khz;
	} else if (s_samplerate == 22050) {
		s_sndHeader.sampleRate = rate22khz;
	} else {
		s_sndHeader.sampleRate = rate11khz;
	}
	s_sndHeader.loopStart = 0;
	s_sndHeader.loopEnd = 0;
	s_sndHeader.encode = extSH;
	s_sndHeader.baseFrequency = 0;
	s_sndHeader.numFrames = SUBMISSION_CHUNK / 2;
	s_sndHeader.markerChunk = NULL;
	s_sndHeader.instrumentChunks = NULL;
	s_sndHeader.AESRecording = NULL;
	s_sndHeader.sampleSize = 16;
	
	mySndCmd.cmd = bufferCmd;
	mySndCmd.param1 = 0;
	mySndCmd.param2 = (int)&s_sndHeader;
	SndDoCommand( sc, &mySndCmd, TRUE );
	
	// and another callback
	mySndCmd.cmd = callBackCmd;
	mySndCmd.param1 = 0;
	mySndCmd.param2 = 0;
	SndDoCommand( sc, &mySndCmd, TRUE );

	s_chunkCount++;		// this is the next buffer we will submit

}

int MacSoundInit(void)
{
	// create a sound channel
	if (!s_sndChan) {
		SndCodePtr = NewSndCallBackUPP(S_Callback);
		if (SndCodePtr) {
			if (!SndNewChannel( &s_sndChan, sampledSynth, initStereo, SndCodePtr)) {
				// que up the first submission-chunk sized buffer
				s_chunkCount = 0;
				S_Callback( s_sndChan, NULL );
				return TRUE;
			}
			DisposeSndCallBackUPP(SndCodePtr);
			SndCodePtr = 0;
		}
	}
	return FALSE;
}

void MacSoundShutdown(void)
{
	if (s_sndChan) {
		SndDisposeChannel(s_sndChan, TRUE );
		s_sndChan = NULL;
	}
	if (SndCodePtr) {
		DisposeSndCallBackUPP(SndCodePtr);
		SndCodePtr = 0;
	}
}