#ifndef __MACFUNCS_H__
#define __MACFUNCS_H__

#ifndef __BURGER__
#include <burger.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

// SYS_MAC.C

extern int LaunchingGameRanger;
extern void Mac_SetCommandLine(char *clstr);

// MAC_LIBUTIL.C

extern void *LoadMacLibrary(char *name);
extern void FreeMacLibrary(void *ptrref);
extern void *GetSymbol(void *ptrref, char *symname);
extern char *Mac_AddressToSymbol(void *addr);
extern void *Mac_SymbolToAddress(char *symb);

// MAC_APPLEVENT.C

extern void Mac_InitAppleEventHandler(void);
extern void Mac_KillAppleEventHandler(void);

// MAC_MISC.C

extern char *_strdate2(char *str);
extern char *_strtime2(char *str);
extern const char *Sys_FindFirst (const char *path, unsigned musthave, unsigned canthave);
extern const char *Sys_FindNext (unsigned musthave, unsigned canthave);
extern void Sys_FindClose (void);
extern void InitTheBurger(void);
extern void	Sys_Init (void);
extern void Mac_KillEvents(void);
extern void Mac_WNE(Bool isStartup);
extern void MDebugXString(char *bah);
extern char *Mac_GetTextScrap(void);
extern char Mac_ConsoleInput(void);
extern void Mac_InitInputLine(void);

// Mac_osinit.c

extern void MacOSStartup(void);
extern void MacOSShutdown(void);

// MAC_OT.C

extern int OT_InitUDP(const char *net_interface, int port);
extern void OT_KillUDP(int conref);
extern int OT_BroadcastUDP(int cref, unsigned char *ipref, unsigned short *portref, int length, void *data);
extern int OT_SendUDP(int cref, unsigned char *ipref, unsigned short *portref, int length, void *data);
extern int OT_GetUDP(int cref, void *data, int maxleng, unsigned char *theAddr, unsigned short *thePort);

// MACOS_SND.C

extern int MacSoundInit(void);
extern void MacSoundShutdown(void);

// MAC_MENUBAR.C

extern void DoCommandLineDialog(void);
extern void DoAboutDialog(void);
extern void DoMacFatalDialog(const char *mess);
extern void Mac_MenuBarInit(void);
extern void Mac_MenuPrepForSelect(void);
extern int Mac_MenuBarDispatch(int inMenu, const short inModifiers);

// MAC_BACKGROUND.C

extern int gResumeSelected;
extern int gQuitSelected;
extern int MacOSBackground(void);

// Sys_mac.c

extern void Sys_InitConsole(void);

#ifdef __cplusplus
}
#endif

#endif