//-----------------------------------------------------------------------------
//
//  $Logfile:: /Source/CL_console.h                                           $
// $Revision:: 2                                                              $
//   $Author:: Burgermac                                                      $
//     $Date:: 12/27/00 7:05 PM                                               $
//
// Copyright (C) 1998 by Ritual Entertainment, Inc.
// All rights reserved.
//
// This source is may not be distributed and/or modified without
// expressly written permission by Ritual Entertainment, Inc.
//
// DESCRIPTION:
// console
//

#ifndef __CL_CONSOLE_H__
#define __CL_CONSOLE_H__

#ifndef __BURGER__
#include <burger.h>
#endif

#ifdef SIN
#define	NUM_CON_TIMES 8
#else
#define	NUM_CON_TIMES 4
#endif

#include "qcommon.h"
#define		CON_TEXTSIZE	32768
typedef struct
{
	qboolean	initialized;

	char	text[CON_TEXTSIZE];
	int		current;		// line where next message will be printed
	int		x;				// offset in current line for next print
	int		display;		// bottom of console displays this line

	int		ormask;			// high bit mask for colored characters

	int 	linewidth;		// characters across screen
	int		totallines;		// total lines in console scrollback

	float	cursorspeed;

	int		vislines;

	float	times[NUM_CON_TIMES];	// cls.realtime time the line was generated
								// for transparent notify lines
} console_t;

extern	console_t	con;

void Con_DrawCharacter (int cx, int line, int num);

void Con_CheckResize (void);
void Con_Init (void);
void Con_DrawConsole (float frac);
#ifdef SIN
void Con_Print ( const char *txt);
void Con_CenteredPrint (const char *text);
#else
void Con_Print (char *txt);
void Con_CenteredPrint (char *text);
#endif
void Con_Clear_f (void);
void Con_DrawNotify (void);
void Con_ClearNotify (void);
void Con_ToggleConsole_f (void);

#endif