//-----------------------------------------------------------------------------
//
//  $Logfile:: /Source/cl_main.c                                              $
// $Revision:: 4                                                              $
//   $Author:: Burgermac                                                      $
//     $Date:: 8/10/01 6:00 PM                                                $
//
// Copyright (C) 1998 by Ritual Entertainment, Inc.
// All rights reserved.
//
// This source is may not be distributed and/or modified without
// expressly written permission by Ritual Entertainment, Inc.
//
// DESCRIPTION:
// client main loop
//

#include "client.h"
#ifdef SIN
#include <ctype.h>
#endif

#ifdef SIN_ARCADE
#include "..\game\\arcade_comm.h"
#endif

cvar_t	*freelook;

cvar_t	*adr0;
cvar_t	*adr1;
cvar_t	*adr2;
cvar_t	*adr3;
cvar_t	*adr4;
cvar_t	*adr5;
cvar_t	*adr6;
cvar_t	*adr7;
cvar_t   *adr8;

cvar_t	*cl_stereo_separation;
cvar_t	*cl_stereo;

cvar_t	*rcon_client_password;
cvar_t	*rcon_address;

cvar_t	*cl_noskins;
cvar_t	*cl_autoskins;
cvar_t	*cl_footsteps;
cvar_t	*cl_timeout;
cvar_t	*cl_predict;
cvar_t	*cl_maxfps;
cvar_t	*cl_gun;

cvar_t	*cl_add_particles;
cvar_t	*cl_add_lights;
cvar_t	*cl_add_entities;
cvar_t	*cl_add_blend;
#ifdef SIN
cvar_t   *cl_add_triangles;
cvar_t   *cl_add_detailmodels;
cvar_t   *cl_add_bulletholes;
cvar_t   *cl_add_glows;
#ifndef REF_HARD_LINKED
cvar_t   *precache;
#else
extern cvar_t *precache;
#endif
cvar_t   *cl_forcecinematic;
int      cl_total=0;
int      cl_current=0;
#endif

cvar_t	*cl_shownet;
cvar_t	*cl_showmiss;
cvar_t	*cl_showclamp;

cvar_t	*cl_paused;
cvar_t	*cl_timedemo;

cvar_t	*lookspring;
cvar_t	*lookstrafe;
cvar_t	*sensitivity;

cvar_t	*m_pitch;
cvar_t	*m_yaw;
cvar_t	*m_forward;
cvar_t	*m_side;

cvar_t	*cl_lightlevel;

//
// userinfo
//
cvar_t	*info_password;
cvar_t	*name;
cvar_t	*skin;
cvar_t	*rate;
cvar_t	*msg;
cvar_t	*hand;
#ifdef SIN
cvar_t *cl_speechdelay;
cvar_t *cl_nospeech;
cvar_t *cl_oldnoclip;
cvar_t *cl_oldladders;
cvar_t *zoomscale;
cvar_t *cl_dumpdemo;
cvar_t *cl_document;
cvar_t *cl_demoplaying;
cvar_t *model;
// 2015 code
cvar_t *bikeskin;
cvar_t *bikemodel;

//***
cvar_t *dt0;
cvar_t *dt1;
cvar_t *dt2;
cvar_t *dt3;
cvar_t *dt4;
cvar_t *dt5;
cvar_t *dtprint;
//***

#endif

client_static_t	cls;
client_state_t	cl;

centity_t		cl_entities[MAX_EDICTS];

entity_state_t	cl_parse_entities[MAX_PARSE_ENTITIES];

extern   cvar_t *allow_download;
extern	cvar_t *allow_download_players;
extern	cvar_t *allow_download_models;
extern	cvar_t *allow_download_sounds;
extern	cvar_t *allow_download_maps;

//======================================================================


/*
====================
CL_WriteDemoMessage

Dumps the current net message, prefixed by the length
====================
*/
void CL_WriteDemoMessage (void)
{
	int		len, swlen;

	// the first eight bytes are just packet sequencing stuff
	len = net_message.cursize-8;
	swlen = LittleLong(len);
	fwrite (&swlen, 4, 1, cls.demofile);
	fwrite (net_message.data+8,	len, 1, cls.demofile);
}


/*
====================
CL_Stop_f

stop recording a demo
====================
*/
void CL_Stop_f (void)
{
	int		len;

	if (!cls.demorecording)
	{
		Com_Printf ("Not recording a demo.\n");
		return;
	}

// finish up
	len = -1;
	fwrite (&len, 4, 1, cls.demofile);
	fclose (cls.demofile);
	cls.demofile = NULL;
	cls.demorecording = FALSE;
	Com_Printf ("Stopped demo.\n");
}

#ifdef SIN
/*
=====================
CL_RecordConsole
=====================
*/

static void CL_RecordConsole(console3d_t *p, sizebuf_t *buf)
   {
   console_state_t	nullconstate;
   console_state_t clcon;
   char	buffer[MAX_BUFFER_LENGTH], buffer2[MAX_BUFFER_LENGTH];
   int   l,x,i,j;
   char  *line;
   int   start=0;
   int   end=0;

	FastMemSet(&clcon, 0, sizeof(clcon));
	FastMemSet(&nullconstate, 0, sizeof(nullconstate));

	clcon.number = p->console_number;
	Burger::StringCopy(clcon.console_name, p->console_name);
	clcon.name_update_time = -1;

	if (p->scrollcon)
		clcon.spawnflags |= 2;
	if (p->menucon)
		clcon.spawnflags |= 4;

	clcon.create_time = -1;
	clcon.layout_update_time = -1;
	if (p->menu_file[0])
		clcon.menufile_update_time = -1;
	clcon.red   = p->r;
	clcon.green = p->g;
	clcon.blue  = p->b;
	clcon.alpha = p->a;
	Burger::StringCopy(clcon.layout,p->LayoutPtr);
	clcon.virtual_width = p->virtual_width;
	clcon.virtual_height = p->virtual_height;
	clcon.fraction = p->fraction;
	clcon.rows = p->rows;
	clcon.cols = p->columns;
	clcon.linepos = p->key_linepos;
	clcon.cmdline[0] = 0;
	clcon.menu_level = p->current_menu_level;
	clcon.sel_menu_item = p->sel_menu_item;
	clcon.focus = p->focus;
	clcon.consoleactive = p->active;
	clcon.menuactive = p->drawmenu;

      // Store the current state of the buffer.
      {

      FastMemSet(buffer,0,sizeof(buffer));
      FastMemSet(buffer2,0,sizeof(buffer2));

      // We only need to save the last 1024 characters of the console.
      buffer[p->con.linewidth] = 0;
      for (l = p->con.current - p->con.totallines + 1 ; l <= p->con.current ; l++)
         {
		   line = p->con.text + (l%p->con.totallines)*p->con.linewidth;
         strncpy (buffer, line, p->con.linewidth);

         for (x=p->con.linewidth-1 ; x>=0 ; x--)
		      {
			   if (buffer[x] == ' ')
				   buffer[x] = 0;
			   else
				   break;
            }

         buffer[x+1] = '\n';

         if (buffer[0])
            {
            char *str = &buffer[0];
            char *bufptr = &buffer2[0];
            while (*str)
               {
               if ( (end+1)%MAX_BUFFER_LENGTH == (start) )
                  {
                  start = (start + 1)%MAX_BUFFER_LENGTH;
                  }
               bufptr[end]=*str;
               end = (end+1) % MAX_BUFFER_LENGTH;
               str++;
               }
            }
         }

      // Re-order buffer so it is linear
      for (i=start,j=0;i<end;i=i+1%MAX_BUFFER_LENGTH,j++)
         buffer[j] = buffer2[i];
      }
   MSG_WriteByte (buf, svc_spawnconbaseline);
   MSG_WriteDeltaConsoleForDemo (&nullconstate, &clcon, buf, TRUE, buffer2);
   }

static void CL_RecordSurface(csurface_t *surf, sizebuf_t *buf)
   {
   char temp[256];

   surface_state_t nullsurfstate;
   surface_state_t clsurf;

   FastMemSet(&clsurf, 0, sizeof(clsurf));
   FastMemSet(&nullsurfstate, 0, sizeof(nullsurfstate));

   nullsurfstate.magnitude = 1;

   Burger::StringCopy(temp,surf->groupname);
   clsurf.name = &temp[0];
   clsurf.number = surf->groupnumber;
   clsurf.trans_state = surf->trans_state;
   clsurf.trans_mag = surf->trans_mag;
   clsurf.trans_angle = surf->trans_angle;
   clsurf.translucence = surf->translucence;
   clsurf.magnitude = surf->magnitude;
   clsurf.frequency = surf->frequency;
   clsurf.damage_frame = surf->animation_frame;

   MSG_WriteByte (buf, svc_spawnsurfbaseline);
   MSG_WriteDeltaSurface (&nullsurfstate, &clsurf, buf, TRUE);
   }
#endif

/*
====================
CL_Record_f

record <demoname>

Begins recording a demo from the current position
====================
*/
void CL_Record_f (void)
{
	char	name[MAX_OSPATH];
	char	buf_data[MAX_MSGLEN];
	sizebuf_t	buf;
	int		i;
	int		len;
	entity_state_t	*ent;
	entity_state_t	nullstate;
#ifdef SIN
   console3d_t *p;
#endif

	if (Cmd_Argc() != 2)
	{
		Com_Printf ("record <demoname>\n");
		return;
	}

	if (cls.demorecording)
	{
      Com_Printf ("Already recording.\n");
		return;
	}

	if (cls.state != ca_active)
	{
		Com_Printf ("You must be in a level to record.\n");
		return;
	}

	//
	// open the demo file
	//
	Com_sprintf (name, sizeof(name), "%s/demos/%s.dm2", FS_Gamedir(), Cmd_Argv(1));

	Com_Printf ("recording to %s.\n", name);
	FS_CreatePath (name);
	cls.demofile = QuakeOpenAFile (name, "wb");
	if (!cls.demofile)
	{
		Com_Printf ("ERROR: couldn't open.\n");
		return;
	}
	cls.demorecording = TRUE;

	// don't start saving messages until a non-delta compressed message is received
	cls.demowaiting = TRUE;

	//
	// write out messages to hold the startup information
	//
	SZ_Init (&buf,(Word8 *) buf_data, sizeof(buf_data));

	// send the serverdata
	MSG_WriteByte (&buf, svc_serverdata);
	MSG_WriteLong (&buf, PROTOCOL_VERSION);
	MSG_WriteLong (&buf, 0x10000 + cl.servercount);
	MSG_WriteByte (&buf, 1);	// demos are allways attract loops
	MSG_WriteString (&buf, cl.gamedir);
	MSG_WriteShort (&buf, cl.playernum);

	MSG_WriteString (&buf, cl.configstrings[CS_NAME]);

	// configstrings
	for (i=0 ; i<MAX_CONFIGSTRINGS ; i++)
	{
		if (cl.configstrings[i][0])
		{
#ifdef SIN
			if (buf.cursize + Burger::StringLength (cl.configstrings[i]) + 128 > buf.maxsize)
#else
			if (buf.cursize + Burger::StringLength (cl.configstrings[i]) + 32 > buf.maxsize)
#endif
			{	// write it out
				len = LittleLong (buf.cursize);
				fwrite (&len, 4, 1, cls.demofile);
				fwrite (buf.data, buf.cursize, 1, cls.demofile);
				buf.cursize = 0;
			}

			MSG_WriteByte (&buf, svc_configstring);
			MSG_WriteShort (&buf, i);
			MSG_WriteString (&buf, cl.configstrings[i]);
		}
	}

#ifdef SIN
 	MSG_WriteByte (&buf, svc_stufftext);
	MSG_WriteString (&buf, "loadmap\n");
#endif

	// baselines
	FastMemSet(&nullstate, 0, sizeof(nullstate));

#ifdef SIN
	// Set up the default baseline values
	nullstate.scale = 1.0;
	nullstate.alpha = 1.0;
	nullstate.renderfx = RF_FRAMELERP;
#endif

	for (i=0; i<MAX_EDICTS ; i++)
	{
		ent = &cl_entities[i].baseline;
		
#ifdef SIN
      if (!ent->modelindex && !ent->sound && !ent->effects)
			continue;
#else
      if (!ent->modelindex)
			continue;
#endif

#ifdef SIN
		if (buf.cursize + 128 > buf.maxsize)
#else
		if (buf.cursize + 64 > buf.maxsize)
#endif
		{	// write it out
			len = LittleLong (buf.cursize);
			fwrite (&len, 4, 1, cls.demofile);
			fwrite (buf.data, buf.cursize, 1, cls.demofile);
			buf.cursize = 0;
		}

		MSG_WriteByte (&buf, svc_spawnbaseline);
		MSG_WriteDeltaEntity (&nullstate, &cl_entities[i].baseline, &buf, TRUE, TRUE);
	}

#ifdef SIN
   // Console baselines
	for (p=active_consoles ; p ; p=p->next)
      {
      if (p->console_number)
         {
   	   // write out the message up to this point because
         // consoles eat up a lot of space.
	   	len = LittleLong (buf.cursize);
		   fwrite (&len, 4, 1, cls.demofile);
		   fwrite (buf.data, buf.cursize, 1, cls.demofile);
		   buf.cursize = 0;
         CL_RecordConsole(p,&buf);
         }
      }


   // Surface Baselines
      {
      csurface_t *surf;
      surf = CM_Surfinfos();
      for (i=0;i<CM_NumSurfinfos();i++)
         {
         if (!isdigit(surf[i].groupname[0]) || ( surf[i].flags & SURF_DAMAGE ))
            {
            if (buf.cursize + 64 > buf.maxsize)
               {
               len = LittleLong (buf.cursize);
               fwrite (&len, 4, 1, cls.demofile);
	            fwrite (buf.data, buf.cursize, 1, cls.demofile);
	            buf.cursize = 0;
               }
            CL_RecordSurface(&surf[i],&buf);
            }
         }
      }
#endif
	MSG_WriteByte (&buf, svc_stufftext);
	MSG_WriteString (&buf, "precache\n");

	// write it to the demo file

	len = LittleLong (buf.cursize);
	fwrite (&len, 4, 1, cls.demofile);
	fwrite (buf.data, buf.cursize, 1, cls.demofile);

	// the rest of the demo file will be individual frames
}



//======================================================================

/*
===================
Cmd_ForwardToServer

adds the current command line as a clc_stringcmd to the client message.
things like godmode, noclip, etc, are commands directed to the server,
so when they are typed in at the console, they will need to be forwarded.
===================
*/
void Cmd_ForwardToServer (void)
{
   const char  *cmd;

	cmd = Cmd_Argv(0);
	if (cls.state <= ca_connected || *cmd == '-' || *cmd == '+')
	{
		Com_Printf ("Unknown command \"%s\"\n", cmd);
		return;
	}

	MSG_WriteByte (&cls.netchan.message, clc_stringcmd);
	SZ_Print (&cls.netchan.message, cmd);
	if (Cmd_Argc() > 1)
	{
		SZ_Print (&cls.netchan.message, " ");
		SZ_Print (&cls.netchan.message, Cmd_Args());
	}
}

/*void CL_Setenv_f( void )
{
   int argc = Cmd_Argc();

	if ( argc > 2 )
	{
		char buffer[1000];
		int i;

		Burger::StringCopy( buffer, Cmd_Argv(1) );
		strcat( buffer, "=" );

		for ( i = 2; i < argc; i++ )
		{
			strcat( buffer, Cmd_Argv( i ) );
			strcat( buffer, " " );
		}

		putenv( buffer );
	}
	else if ( argc == 2 )
	{
		char *env = getenv( Cmd_Argv(1) );

		if ( env )
		{
			Com_Printf( "%s=%s\n", Cmd_Argv(1), env );
		}
		else
		{
			Com_Printf( "%s undefined\n", Cmd_Argv(1), env );
		}
	}
}
*/
#ifdef SIN
/*
===========
CL_Remark_f
===========
*/
static void CL_Remark_f ( void )
   {
   // Does nothing
   return;
   }
#endif

/*
==================
CL_ForwardToServer_f
==================
*/
static void CL_ForwardToServer_f (void)
{
   if (cls.state != ca_connected && cls.state != ca_active)
	{
		Com_Printf ("Can't \"%s\", not connected\n", Cmd_Argv(0));
		return;
	}

	// don't forward the first argument
	if (Cmd_Argc() > 1)
	{
		MSG_WriteByte (&cls.netchan.message, clc_stringcmd);
		SZ_Print (&cls.netchan.message, Cmd_Args());
	}
}


/*
==================
CL_Pause_f
==================
*/
void CL_Pause_f (void)
{
	// never pause in multiplayer
	if (Cvar_VariableValue ("maxclients") > 1 || !Com_ServerState ())
	{
		Cvar_SetValue ("paused", 0);
		return;
	}

	Cvar_SetValue ("paused", !cl_paused->value);
}

/*
==================
CL_Quit_f
==================
*/
void CL_Quit_f (void)
{
	CL_Disconnect ();
	Com_Quit ();
}

/*
================
CL_Drop

Called after an ERR_DROP was thrown
================
*/
void CL_Drop (void)
{
#ifdef SIN
   SCR_EndLoadingPlaque ();
   cls.intermission_active = FALSE;
#endif

   if (cls.state == ca_uninitialized)
		return;
   if (cls.state == ca_disconnected)
		return;

	CL_Disconnect ();

	// drop loading plaque unless this is the initial game start
	if (cls.disable_servercount != -1)
		SCR_EndLoadingPlaque ();	// get rid of loading plaque
}


/*
=======================
CL_SendConnectPacket

We have gotten a challenge from the server, so try and
connect.
======================
*/
static void CL_SendConnectPacket (void)
{
	netadr_t	adr;
	int		port;

	if (!NET_StringToAdr (cls.servername, &adr))
	{
		Com_Printf ("Bad server address\n");
		cls.connect_time = 0;
		return;
	}
	if (adr.port == 0)
		adr.port = BigShort (PORT_SERVER);

	port = Cvar_VariableValue ("qport");
	userinfo_modified = FALSE;

	Netchan_OutOfBandPrint (NS_CLIENT, adr, "connect %i %i %i \"%s\"\n",
		PROTOCOL_VERSION, port, cls.challenge, Cvar_Userinfo() );
}

/*
=================
CL_CheckForResend

Resend a connect message if the last one has timed out
=================
*/
static void CL_CheckForResend (void)
{
	netadr_t	adr;

	// if the local server is running and we aren't
	// then connect
	if (cls.state == ca_disconnected && Com_ServerState() )
	{
		cls.state = ca_connecting;
		strncpy (cls.servername, "localhost", sizeof(cls.servername)-1);
		// we don't need a challenge on the localhost
		CL_SendConnectPacket ();
		return;
//		cls.connect_time = -99999;	// CL_CheckForResend() will fire immediately
	}

	// resend if we haven't gotten a reply yet
	if (cls.state != ca_connecting)
		return;

	if (cls.realtime - cls.connect_time < 3000)
		return;

	if (!NET_StringToAdr (cls.servername, &adr))
	{
		Com_Printf ("Bad server address\n");
		cls.state = ca_disconnected;
		return;
	}
	if (adr.port == 0)
		adr.port = BigShort (PORT_SERVER);

	cls.connect_time = cls.realtime;	// for retransmit requests

	Com_Printf ("Connecting to %s...\n", cls.servername);

	Netchan_OutOfBandPrint (NS_CLIENT, adr, "getchallenge\n");
}


/*
================
CL_Connect_f

================
*/
static void CL_Connect_f (void)
{
	const char	*server;

	if (Cmd_Argc() != 2)
	{
		Com_Printf ("usage: connect <server>\n");
		return;
	}

	if (Com_ServerState ())
	{	// if running a local server, kill it and reissue
		SV_Shutdown (va("Server quit\n", msg), FALSE);
	}
	else
	{
		CL_Disconnect ();
	}

	server = Cmd_Argv (1);

	NET_Config (TRUE);		// allow remote

	CL_Disconnect ();

   cls.state = ca_connecting;
	strncpy (cls.servername, server, sizeof(cls.servername)-1);
	cls.connect_time = -99999;	// CL_CheckForResend() will fire immediately
}


/*
=====================
CL_Rcon_f

  Send the rest of the command line over as
  an unconnected command.
=====================
*/
static void CL_Rcon_f (void)
{
	char	message[1024];
	int		i;
	netadr_t	to;

	if (!rcon_client_password->CVarString)
	{
		Com_Printf ("You must set 'rcon_password' before\n"
					"issuing an rcon command.\n");
		return;
	}

	message[0] = (char)255;
	message[1] = (char)255;
	message[2] = (char)255;
	message[3] = (char)255;
	message[4] = 0;

   NET_Config (TRUE);      // allow remote

	strcat (message, "rcon ");

	strcat (message, rcon_client_password->CVarString);
	strcat (message, " ");

	for (i=1 ; i<Cmd_Argc() ; i++)
	{
		strcat (message, Cmd_Argv(i));
		strcat (message, " ");
	}

	if (cls.state >= ca_connected)
		to = cls.netchan.remote_address;
	else
	{
		if (!Burger::StringLength(rcon_address->CVarString))
		{
			Com_Printf ("You must either be connected,\n"
						"or set the 'rcon_address' cvar\n"
						"to issue rcon commands\n");

			return;
		}
		NET_StringToAdr (rcon_address->CVarString, &to);
      if (to.port == 0)
			to.port = BigShort (PORT_SERVER);
   }

	NET_SendPacket (NS_CLIENT, Burger::StringLength(message)+1, message, to);
}


/*
=====================
CL_ClearState

=====================
*/
void CL_ClearState (void)
{
#ifdef SIN
	int		i;
	entity_state_t	*ent;
#endif

	S_StopAllSounds ();
	CL_ClearEffects ();
	CL_ClearTEnts ();

// wipe the entire cl structure
	FastMemSet(&cl, 0, sizeof(cl));
	FastMemSet(&cl_entities, 0, sizeof(cl_entities));

#ifdef SIN
	// Set up the default baseline values
	for (i=0; i<MAX_EDICTS ; i++)
	{
		ent = &cl_entities[i].baseline;
		ent->scale = 1.0;
		ent->alpha = 1.0;
		ent->renderfx = RF_FRAMELERP;
	}
#endif

	SZ_Clear (&cls.netchan.message);

}

/*
=====================
CL_Disconnect

Goes from a connected state to full screen console state
Sends a disconnect message to the server
This is also called on Com_Error, so it shouldn't cause any errors
=====================
*/
void CL_Disconnect (void)
{
	byte	final[32];

	if (cls.state == ca_disconnected)
		return;

	if (cl_timedemo && cl_timedemo->value)
	{
		int	time;

		time = Sys_Milliseconds () - cl.timedemo_start;
		if (time > 0)
			Com_Printf ("%i frames, %3.1f seconds: %3.1f fps\n", cl.timedemo_frames,
			time/1000.0, cl.timedemo_frames*1000.0 / time);
	}

   VectorClear (cl.refdef.blend);
	re.CinematicSetPalette(NULL);

#ifdef SIN
	CONSOLE_Exit(cls.mainconsole);
#else
   M_ForceMenuOff ();
#endif

	cls.connect_time = 0;

	SCR_StopCinematic ();

	if (cls.demorecording)
		CL_Stop_f ();

	// send a disconnect message to the server
	final[0] = clc_stringcmd;
	Burger::StringCopy ((char *)final+1, "disconnect");
	Netchan_Transmit (&cls.netchan, Burger::StringLength((char *)final), final);
	Netchan_Transmit (&cls.netchan, Burger::StringLength((char *)final), final);
	Netchan_Transmit (&cls.netchan, Burger::StringLength((char *)final), final);

	CL_ClearState ();

   // stop download
	if (cls.download) {
		fclose(cls.download);
		cls.download = NULL;
	}

   cls.state = ca_disconnected;
}

void CL_Disconnect_f (void)
{
	Com_Error (ERR_DROP, "Disconnected from server");
}


/*
====================
CL_Packet_f

packet <destination> <contents>

Contents allows \n escape character
====================
*/
static void CL_Packet_f (void)
{
	char	send[2048];
	int		i, l;
	const char	*in;
	char *out;
	netadr_t	adr;

	if (Cmd_Argc() != 3)
	{
		Com_Printf ("packet <destination> <contents>\n");
		return;
	}

	NET_Config (TRUE);		// allow remote

	if (!NET_StringToAdr (Cmd_Argv(1), &adr))
	{
		Com_Printf ("Bad address\n");
		return;
	}
	if (!adr.port)
		adr.port = BigShort (PORT_SERVER);

	in = Cmd_Argv(2);
	out = send+4;
	send[0] = send[1] = send[2] = send[3] = (char)0xff;

	l = Burger::StringLength (in);
	for (i=0 ; i<l ; i++)
	{
		if (in[i] == '\\' && in[i+1] == 'n')
		{
			*out++ = '\n';
			i++;
		}
		else
			*out++ = in[i];
	}
	*out = 0;

	NET_SendPacket (NS_CLIENT, out-send, send, adr);
}

/*
=================
CL_Changing_f

Just sent as a hint to the client that they should
drop to full console
=================
*/
static void CL_Changing_f (void)
{
   //if we are downloading, we don't change!  This so we don't suddenly stop downloading a map
	if (cls.download)
		return;

   SCR_BeginLoadingPlaque ();
	cls.state = ca_connected;	// not active anymore, but not disconnected
	Com_Printf ("\nChanging map...\n");
}


/*
=================
CL_Reconnect_f

The server is changing levels
=================
*/
static void CL_Reconnect_f (void)
{
   //if we are downloading, we don't change!  This so we don't suddenly stop downloading a map
	if (cls.download)
		return;

	S_StopAllSounds ();
	if (cls.state == ca_connected) {
		Com_Printf ("reconnecting...\n");
		cls.state = ca_connected;
		MSG_WriteChar (&cls.netchan.message, clc_stringcmd);
		MSG_WriteString (&cls.netchan.message, "new");
		return;
	}

	if (*cls.servername) {
		if (cls.state >= ca_connected) {
			CL_Disconnect();
			cls.connect_time = cls.realtime - 1500;
		} else
			cls.connect_time = -99999; // fire immediately

		cls.state = ca_connecting;
		Com_Printf ("reconnecting...\n");
	}
}

/*
=================
CL_ParseStatusMessage

Handle a reply from a ping
=================
*/
static void CL_ParseStatusMessage (void)
{
	const char	*s;

	s = MSG_ReadString(&net_message);

	Com_Printf ("%s\n", s);

#ifdef SIN
   MENU_AddToServerList (net_from, s);
#else
   M_AddToServerList (net_from, s);
#endif
}


/*
=================
CL_PingServers_f
=================
*/
void CL_PingServers_f (void)
{
	int			i;
	netadr_t	adr;
	char		name[32];
	const char		*adrstring;
   cvar_t      *noudp;
	cvar_t		*noipx;

	NET_Config (TRUE);		// allow remote

	// send a broadcast packet
	Com_Printf ("pinging broadcast...\n");

   noudp = Cvar_Get ("noudp", "0", CVAR_NOSET);
	if (!noudp->value)
	{
		adr.type = NA_BROADCAST;
		adr.port = BigShort(PORT_SERVER);
		Netchan_OutOfBandPrint (NS_CLIENT, adr, va("info %i", PROTOCOL_VERSION));
	}

	noipx = Cvar_Get ("noipx", "0", CVAR_NOSET);
	if (!noipx->value)
	{
		adr.type = NA_BROADCAST_IPX;
		adr.port = BigShort(PORT_SERVER);
		Netchan_OutOfBandPrint (NS_CLIENT, adr, va("info %i", PROTOCOL_VERSION));
	}

	// send a packet to each address book entry
	for (i=0 ; i<16 ; i++)
	{
		Com_sprintf (name, sizeof(name), "adr%i", i);
		adrstring = Cvar_VariableString (name);
		if (!adrstring || !adrstring[0])
			continue;

		Com_Printf ("pinging %s...\n", adrstring);
		if (!NET_StringToAdr (adrstring, &adr))
		{
			Com_Printf ("Bad address: %s\n", adrstring);
			continue;
		}
		if (!adr.port)
			adr.port = BigShort(PORT_SERVER);
		Netchan_OutOfBandPrint (NS_CLIENT, adr, va("info %i", PROTOCOL_VERSION));
	}
}


/*
=================
CL_Skins_f

Load or download any custom player skins and models
=================
*/
static void CL_Skins_f (void)
{
	int		i;

	for (i=0 ; i<MAX_CLIENTS ; i++)
   	{
		if (!cl.configstrings[CS_PLAYERSKINS+i][0])
			continue;
		Com_Printf ("client %i: %s\n", i, cl.configstrings[CS_PLAYERSKINS+i]);
		if(cl.configstrings[CS_BIKESKINS+i][0])
			Com_Printf ("client %i: %s\n", i, cl.configstrings[CS_BIKESKINS+i]);
		SCR_UpdateScreen ();
		Sys_SendKeyEvents ();	// pump message loop
		CL_ParseClientinfo (i);
		if(cl.configstrings[CS_BIKESKINS+i][0])
			CL_ParseBikeinfo (i);
	   }
}


/*
=================
CL_ConnectionlessPacket

Responses to broadcasts, etc
=================
*/
static void CL_ConnectionlessPacket (void)
{
	const char	*s;
	const char	*c;

	MSG_BeginReading (&net_message);
	MSG_ReadLong (&net_message);	// skip the -1

	s = MSG_ReadStringLine (&net_message);

   Cmd_TokenizeString (s, FALSE);

	c = Cmd_Argv(0);

	Com_Printf ("%s: %s\n", NET_AdrToString (net_from), c);

	// server connection
   if (!strcmp(c, "client_connect"))
	{
		if (cls.state == ca_connected)
		{
			Com_Printf ("Dup connect received.  Ignored.\n");
			return;
		}
      Netchan_Setup (NS_CLIENT, &cls.netchan, net_from, cls.quakePort);
		MSG_WriteChar (&cls.netchan.message, clc_stringcmd);
		MSG_WriteString (&cls.netchan.message, "new");
		cls.state = ca_connected;
		return;
	}

	// server responding to a status broadcast
	if (!strcmp(c, "info"))
	{
		CL_ParseStatusMessage ();
		return;
	}

	// remote command from gui front end
	if (!strcmp(c, "cmd"))
	{
		if (!NET_IsLocalAddress(net_from))
		{
			Com_Printf ("Command packet from remote host.  Ignored.\n");
			return;
		}
		Sys_AppActivate ();
		s = MSG_ReadString (&net_message);
		Cbuf_AddText (s);
      Cbuf_AddText ("\n");
		return;
	}
	// print command from somewhere
	if (!strcmp(c, "print"))
	{
		s = MSG_ReadString (&net_message);
		Com_Printf (s);
		return;
	}

	// ping from somewhere
	if (!strcmp(c, "ping"))
	{
		Netchan_OutOfBandPrint (NS_CLIENT, net_from, "ack");
		return;
	}

   // challenge from the server we are connecting to
	if (!strcmp(c, "challenge"))
	{
		cls.challenge = atoi(Cmd_Argv(1));
		CL_SendConnectPacket ();
		return;
	}

	// echo request from server
	if (!strcmp(c, "echo"))
	{
		Netchan_OutOfBandPrint (NS_CLIENT, net_from, "%s", Cmd_Argv(1) );
		return;
	}

	Com_Printf ("Unknown command.\n");
}


/*
=================
CL_DumpPackets

A vain attempt to help bad TCP stacks that cause problems
when they overflow
=================
*/
static void CL_DumpPackets (void)
{
	while (NET_GetPacket (NS_CLIENT, &net_from, &net_message))
	{
		Com_Printf ("dumnping a packet\n");
	}
}

/*
=================
CL_ReadPackets
=================
*/
void CL_ReadPackets (void)
{
	while (NET_GetPacket (NS_CLIENT, &net_from, &net_message))
	{
//	Com_Printf ("packet\n");
		//
		// remote command packet
		//
		if (*(int *)net_message.data == -1)
		{
			CL_ConnectionlessPacket ();
			continue;
		}

      if (cls.state == ca_disconnected || cls.state == ca_connecting)
			continue;		// dump it if not connected

		if (net_message.cursize < 8)
		{
			Com_Printf ("%s: Runt packet\n",NET_AdrToString(net_from));
			continue;
		}

		//
		// packet from server
		//
		if (!NET_CompareAdr (&net_from,&cls.netchan.remote_address))
		{
         Com_DPrintf ("%s:sequenced packet without connection\n"
				,NET_AdrToString(net_from));
			continue;
		}
		if (!Netchan_Process(&cls.netchan, &net_message))
			continue;		// wasn't accepted for some reason
		CL_ParseServerMessage ();
	}

	//
	// check timeout
	//
#ifdef SIN
	if (
         cls.state >= ca_connected && !Com_ServerState() &&
         cls.realtime - cls.netchan.last_received > cl_timeout->value*1000
      )
#else
	if (cls.state >= ca_connected
	 && cls.realtime - cls.netchan.last_received > cl_timeout->value*1000)
#endif
	{
		if (++cl.timeoutcount > 5)	// timeoutcount saves debugger
		{
			Com_Printf ("\nServer connection timed out.\n");
			CL_Disconnect ();
			return;
		}
	}
	else
		cl.timeoutcount = 0;

}


//=============================================================================

/*
==============
CL_Userinfo_f
==============
*/
static void CL_Userinfo_f (void)
{
	Com_Printf ("User info settings:\n");
	Info_Print (Cvar_Userinfo());
}

/*
=================
CL_Snd_Restart_f

Restart the sound subsystem so it can pick up
new parameters and flush all sounds
=================
*/
void CL_Snd_Restart_f (void)
{
	S_Shutdown ();
	S_Init ();
#ifdef SIN
	CL_RegisterSounds( FALSE );
#else
	CL_RegisterSounds ();
#endif
}

int precache_check; // for autodownload of precache items
int precache_spawncount;
int precache_tex;
int precache_model_skin;

byte *precache_model; // used for skin checking in alias models

#define PLAYER_MULT 5

//FIXME this needs to be changed for SIN
#define TEXTURE_CNT (CS_PLAYERSKINS + MAX_CLIENTS * PLAYER_MULT)
void CL_LoadMap_f (void);

static int precache_skin = FALSE;
static int precache_damskin = FALSE;
static int precache_icon = FALSE;

void CL_RequestNextDownload (void)
{
#ifdef SIN
	char model       [MAX_QPATH];
   char skin        [MAX_QPATH];
   char damskin     [MAX_QPATH];
   char icon        [MAX_QPATH];
   char scratch     [MAX_QPATH];
   char string      [1024];
   
   // MAP
   if ( precache_check == CS_MODELS ) 
      { 
      precache_check = CS_PLAYERSKINS;
      // check for map file
		if ( allow_download_maps->value )
         {
         if ( !CL_CheckOrDownloadFile( cl.configstrings[CS_MODELS+1] ) )
				return; // started a download
         }
      }
     	
   // SKINS
   if ( allow_download_players->value )
      {
      if ( precache_check >= CS_PLAYERSKINS && precache_check < CS_PLAYERSKINS+MAX_CLIENTS )
         {
		   while ( precache_check < CS_PLAYERSKINS+MAX_CLIENTS &&
			        cl.configstrings[precache_check][0])
            {
            const char *token;
         
            strncpy( string, cl.configstrings[precache_check], sizeof(string)-1 );

            // Name
            token = strtok( string, "\\" );

            // Model
            token = strtok( NULL, "\\" );
            COM_StripExtension( token, scratch );
            Com_sprintf( model, sizeof(model), "models/%s", scratch );

            // Skin
            token = strtok( NULL, "\\" );
            COM_StripExtension( token, scratch );
            Com_sprintf( skin, sizeof(skin), "%s/%s.tga",model, scratch );
            
            // Damage skin
            COM_StripExtension( skin, scratch );
            Com_sprintf( damskin, sizeof(damskin), "%s_dam.tga", scratch );
            
            // Icon
            Com_sprintf( icon, sizeof(icon), "%s_ico.tga", scratch );
            
            
            if ( !precache_skin )
               {            
               if ( !CL_CheckOrDownloadFile( skin ) )
                  {
                  precache_skin = TRUE;
		      		return; // started a download
                  }
               precache_skin = TRUE;
               }
            
            if ( !precache_damskin )
               {            
               if ( !CL_CheckOrDownloadFile( damskin ) )
                  {
                  precache_damskin = TRUE;
		      		return; // started a download
                  }
               precache_damskin = TRUE;
               }

            if ( !precache_icon )
               {            
               if ( !CL_CheckOrDownloadFile( icon ) )
                  {
                  precache_icon = TRUE;
		      		return; // started a download
                  }
               precache_icon = TRUE;
               }

               precache_check++;
               precache_skin = FALSE;
               precache_damskin = FALSE;
               precache_icon = FALSE;
            }
         }
      }

   // Setup the rest of the client
   CL_RegisterSounds( TRUE );
   CL_LoadMap_f();
   CL_PrepRefresh();
#else
	unsigned	map_checksum;		// for detecting cheater maps
	char fn[MAX_OSPATH];
   dmdl_t *pheader;

   if (cls.state != ca_connected)
      return;

	if (!allow_download->value && precache_check < TEXTURE_CNT)
		precache_check = TEXTURE_CNT;

//ZOID
	if (precache_check == CS_MODELS) { // confirm map
		precache_check = CS_MODELS+2; // 0 isn't used
		if (allow_download_maps->value)
			if (!CL_CheckOrDownloadFile(cl.configstrings[CS_MODELS+1]))
				return; // started a download
	}
	if (precache_check >= CS_MODELS && precache_check < CS_MODELS+MAX_MODELS) {
		if (allow_download_models->value) {
			while (precache_check < CS_MODELS+MAX_MODELS &&
				cl.configstrings[precache_check][0]) {
				if (cl.configstrings[precache_check][0] == '*' ||
					cl.configstrings[precache_check][0] == '#') {
					precache_check++;
					continue;
				}
				if (precache_model_skin == 0) {
					if (!CL_CheckOrDownloadFile(cl.configstrings[precache_check])) {
						precache_model_skin = 1;
						return; // started a download
					}
					precache_model_skin = 1;

				}

				// checking for skins in the model
				if (!precache_model) {

					FS_LoadFile (cl.configstrings[precache_check], (void **)&precache_model);
					if (!precache_model) {
						precache_model_skin = 0;
						precache_check++;
						continue; // couldn't load it
					}
					if (LittleLong(*(unsigned *)precache_model) != IDALIASHEADER) {
						// not an alias model
						FS_FreeFile(precache_model);
						precache_model = 0;
						precache_model_skin = 0;
						precache_check++;
						continue;
					}
					pheader = (dmdl_t *)precache_model;
					if (LittleLong (pheader->version) != ALIAS_VERSION) {
						precache_check++;
						precache_model_skin = 0;
						continue; // couldn't load it
					}
				}

				pheader = (dmdl_t *)precache_model;

				while (precache_model_skin - 1 < LittleLong(pheader->num_skins)) {
					if (!CL_CheckOrDownloadFile((char *)precache_model +
						LittleLong(pheader->ofs_skins) +
						(precache_model_skin - 1)*MAX_SKINNAME)) {
						precache_model_skin++;
						return; // started a download
					}
					precache_model_skin++;
				}
				if (precache_model) {
					FS_FreeFile(precache_model);
					precache_model = 0;
				}
				precache_model_skin = 0;
				precache_check++;
			}
		}
		precache_check = CS_SOUNDS;
	}
	if (precache_check >= CS_SOUNDS && precache_check < CS_SOUNDS+MAX_SOUNDS) {
		if (allow_download_sounds->value) {
			if (precache_check == CS_SOUNDS)
				precache_check++; // zero is blank
			while (precache_check < CS_SOUNDS+MAX_SOUNDS &&
				cl.configstrings[precache_check][0]) {
				if (cl.configstrings[precache_check][0] == '*') {
					precache_check++;
					continue;
				}
				Com_sprintf(fn, sizeof(fn), "sound/%s", cl.configstrings[precache_check++]);
				if (!CL_CheckOrDownloadFile(fn))
					return; // started a download
			}
		}
		precache_check = CS_IMAGES;
	}
	if (precache_check >= CS_IMAGES && precache_check < CS_IMAGES+MAX_IMAGES) {
		if (precache_check == CS_IMAGES)
			precache_check++; // zero is blank
		while (precache_check < CS_IMAGES+MAX_IMAGES &&
			cl.configstrings[precache_check][0]) {
			Com_sprintf(fn, sizeof(fn), "pics/%s.pcx", cl.configstrings[precache_check++]);
			if (!CL_CheckOrDownloadFile(fn))
				return; // started a download
		}
		precache_check = CS_PLAYERSKINS;
	}
	// skins are special, since a player has three things to download:
	// model, weapon model and skin
	// so precache_check is now *3
	if (precache_check >= CS_PLAYERSKINS && precache_check < CS_PLAYERSKINS + MAX_CLIENTS * PLAYER_MULT) {
		if (allow_download_players->value) {
			while (precache_check < CS_PLAYERSKINS + MAX_CLIENTS * PLAYER_MULT) {
				int i, n;
				char model[MAX_QPATH], skin[MAX_QPATH], *p;

				i = (precache_check - CS_PLAYERSKINS)/PLAYER_MULT;
				n = (precache_check - CS_PLAYERSKINS)%PLAYER_MULT;

				if (!cl.configstrings[CS_PLAYERSKINS+i][0]) {
					precache_check = CS_PLAYERSKINS + (i + 1) * PLAYER_MULT;
					continue;
				}

				if ((p = strchr(cl.configstrings[CS_PLAYERSKINS+i], '\\')) != NULL)
					p++;
				else
					p = cl.configstrings[CS_PLAYERSKINS+i];
				Burger::StringCopy(model, p);
				p = strchr(model, '/');
				if (!p)
					p = strchr(model, '\\');
				if (p) {
					*p++ = 0;
					Burger::StringCopy(skin, p);
				} else
					*skin = 0;

				switch (n) {
				case 0: // model
					Com_sprintf(fn, sizeof(fn), "players/%s/tris.md2", model);
					if (!CL_CheckOrDownloadFile(fn)) {
						precache_check = CS_PLAYERSKINS + i * PLAYER_MULT + 1;
						return; // started a download
					}
					n++;
					/*FALL THROUGH*/

				case 1: // weapon model
					Com_sprintf(fn, sizeof(fn), "players/%s/weapon.md2", model);
					if (!CL_CheckOrDownloadFile(fn)) {
						precache_check = CS_PLAYERSKINS + i * PLAYER_MULT + 2;
						return; // started a download
					}
					n++;
					/*FALL THROUGH*/

				case 2: // weapon skin
					Com_sprintf(fn, sizeof(fn), "players/%s/weapon.pcx", model);
					if (!CL_CheckOrDownloadFile(fn)) {
						precache_check = CS_PLAYERSKINS + i * PLAYER_MULT + 3;
						return; // started a download
					}
					n++;
					/*FALL THROUGH*/

				case 3: // skin
					Com_sprintf(fn, sizeof(fn), "players/%s/%s.pcx", model, skin);
					if (!CL_CheckOrDownloadFile(fn)) {
						precache_check = CS_PLAYERSKINS + i * PLAYER_MULT + 4;
						return; // started a download
					}
					n++;
					/*FALL THROUGH*/

				case 4: // skin_i
					Com_sprintf(fn, sizeof(fn), "players/%s/%s_i.pcx", model, skin);
					if (!CL_CheckOrDownloadFile(fn)) {
						precache_check = CS_PLAYERSKINS + i * PLAYER_MULT + 5;
						return; // started a download
					}
					// move on to next model
					precache_check = CS_PLAYERSKINS + (i + 1) * PLAYER_MULT;
				}
			}
		}
		// precache phase completed
		precache_check = TEXTURE_CNT;
	}

	if (precache_check == TEXTURE_CNT) {
		precache_check = TEXTURE_CNT+1;
		precache_tex = 0;

		CM_LoadMap (cl.configstrings[CS_MODELS+1], TRUE, &map_checksum);

		if (map_checksum != atoi(cl.configstrings[CS_MAPCHECKSUM]))
			Com_Error (ERR_DROP, "Local map version differs from server: %i != '%s'\n",
			map_checksum, cl.configstrings[CS_MAPCHECKSUM]);
#ifdef SIN
      Com_Dprintf("Updating client sequence number to %i\n", map_sequence_number );
      cl.map_sequence_number = map_sequence_number;
#endif
   }

	// confirm existance of textures, download any that don't exist
	if (precache_check == TEXTURE_CNT+1) {
		// from qcommon/cmodel.c

		if (allow_download->value && allow_download_maps->value) {
			while (precache_tex < numtexinfo) {
				char fn[MAX_OSPATH];

				sprintf(fn, "textures/%s.wal", map_surfaces[precache_tex++].rname);
				if (!CL_CheckOrDownloadFile(fn))
					return; // started a download
			}
		}
		precache_check = TEXTURE_CNT+999;
	}

//ZOID
#ifdef SIN
	CL_RegisterSounds( TRUE );
#else
	CL_RegisterSounds ();
#endif
	CL_PrepRefresh ();

	MSG_WriteByte (&cls.netchan.message, clc_stringcmd);
	MSG_WriteString (&cls.netchan.message, va("begin %i\n", precache_spawncount) );
#endif
}

#ifdef SIN
static void CL_CalculateLoadBar( void )
   {
   int   i;

   cl_total = 5;

   for (i=1 ; i<MAX_MODELS && cl.configstrings[CS_MODELS+i][0] ; i++)
      cl_total++;
   for (i=1 ; i<MAX_IMAGES && cl.configstrings[CS_IMAGES+i][0] ; i++)
      cl_total++;

   cl_current = cl_total;
   cl_total   *= 2;
   }
#endif

/*
=================
CL_Precache_f

The server will send this command right
before allowing the client into the server
=================
*/
static void CL_Precache_f (void)
{
#ifdef SIN
      int i;

      // Setup the intermission layout map for defaults
      CONSOLE_SetupDefaultIntermissionLayoutFile( cl.configstrings[CS_MODELS+1] );

      cl_total = 5;

      for (i=1 ; i<MAX_MODELS && cl.configstrings[CS_MODELS+i][0] ; i++)
         cl_total++;
      for (i=1 ; i<MAX_IMAGES && cl.configstrings[CS_IMAGES+i][0] ; i++)
         cl_total++;

      cl_total += 2 * MAX_SOUNDS;

      cl_current = cl_total;
      cl_total   *= 2;
#else

   //Yet another hack to let old demos work
	//the old precache sequence
	if (Cmd_Argc() < 2) 
   {
      unsigned	map_checksum;		// for detecting cheater maps

      // This has been moved to an explicit command called "loadmap" and
      // will be exec'd after configstrings.
      CM_LoadMap (cl.configstrings[CS_MODELS+1], TRUE, &map_checksum);
      if (map_checksum != atoi(cl.configstrings[CS_MAPCHECKSUM]))
         Com_Error (ERR_DROP, "Local map version differs from server.\n");
      CL_RegisterSounds ();
		CL_PrepRefresh ();
		return;
	}

	precache_check = CS_MODELS;
	precache_spawncount = atoi(Cmd_Argv(1));
	precache_model = 0;
	precache_model_skin = 0;

	CL_RequestNextDownload();
#endif
}

#ifdef SIN_ARCADE

/*
=================
CL_Arcade_PlayerDead_f
=================
*/
void CL_Arcade_PlayerDead_f(void)
   {
   if ( !ARCADE_ComWriteByte( 0x03 ) )
      Com_Error( ERR_DROP, "Could not send lost player life to communications port" );
   }

/*
=================
CL_Arcade_GameOver_f
=================
*/
void CL_Arcade_GameOver_f(void)
   {
   if ( !ARCADE_ComWriteByte( 0x06 ) )
      Com_Error( ERR_DROP, "Could not send end of game to communications port" );
   }

/*
=================
CL_Arcade_PutByte_f
=================
*/
void CL_Arcade_PutByte_f(void)
   {
   if ( Cmd_Argc() < 2 )
      {
      Com_Printf( "Usage: arcade_putbyte [value]\n" );
      return;
      }

   if ( !ARCADE_ComWriteByte( ( byte )atoi( Cmd_Argv( 1 ) ) ) )
      {
      Com_Error( ERR_DROP, "Could not send data to communications port" );
      }
   }

void CL_Arcade_CheckFirst_f(void)
   {
   if ( cl.frame.playerstate.stats[ STAT_FIRSTPLACE ] && !ARCADE_ComWriteByte( 0x5 ) )
      {
      Com_Error( ERR_DROP, "Could not send data to communications port" );
      }
   }

#endif

#ifdef SIN
/*
=================
CL_LoadMap_f

The server will send this command after configstrings, so we can load the 
client side map. This needs to be done before we get the surface baselines
=================
*/
void CL_LoadMap_f (void)
   {
   unsigned map_checksum;

   CM_LoadMap (cl.configstrings[CS_MODELS+1], TRUE, &map_checksum);

   if (map_checksum != atoi(cl.configstrings[CS_MAPCHECKSUM]))
      Com_Error (ERR_DROP, "Local map version differs from server.\n");
   
   cl.map_sequence_number = map_sequence_number;
   Com_DPrintf("Updating client sequence number to %i\n", map_sequence_number );

   MSG_WriteByte (&cls.netchan.message, clc_stringcmd);
   MSG_WriteString (&cls.netchan.message, va("baselines %i 0\n", precache_spawncount ) );
   }

static void CL_PreLoadMap_f( void )
	{
   int i;

   // Hack for demos to work
   if ( Cmd_Argc() < 2 )
      {
      unsigned map_checksum;

      CL_RegisterSounds( TRUE );
      CM_LoadMap (cl.configstrings[CS_MODELS+1], TRUE, &map_checksum);

      if (map_checksum != atoi(cl.configstrings[CS_MAPCHECKSUM]))
         Com_Error (ERR_DROP, "Local map version differs from server.\n");
   
      cl.map_sequence_number = map_sequence_number;
      Com_DPrintf("Updating client sequence number to %i\n", map_sequence_number );

      CL_PrepRefresh();
      return;
      }

   precache_check = CS_MODELS;
   precache_spawncount = atoi(Cmd_Argv(1));
   precache_model = 0;
   precache_model_skin = 0;

   // Setup the intermission layout map for defaults
   CONSOLE_SetupDefaultIntermissionLayoutFile( cl.configstrings[CS_MODELS+1] );

   cl_total = 5;

   for (i=1 ; i<MAX_MODELS && cl.configstrings[CS_MODELS+i][0] ; i++)
   cl_total++;
   for (i=1 ; i<MAX_IMAGES && cl.configstrings[CS_IMAGES+i][0] ; i++)
   cl_total++;

   cl_total += 2 * MAX_SOUNDS;

   cl_current = cl_total;
   cl_total   *= 2;

   CL_RequestNextDownload();
	}

/*
=================
CL_PrecacheDone_f

The server will send this command after the precache is done.  We will
load up a menu that will allow the user to press any key to enter the server.
=================
*/
static void CL_PrecacheDone_f (void)
   {
   precache_spawncount = atoi( Cmd_Argv( 1 ) );

#ifndef SIN_ARCADE
   if ( developer->value == 0 )
      {
      CL_Pause_f();
      MENU_AnyKeyToContinue_f();
      }
   else
      {
	   MSG_WriteByte (&cls.netchan.message, clc_stringcmd);
   	MSG_WriteString (&cls.netchan.message, va("begin %i\n", precache_spawncount ) );
      }
#else
   CL_Begin_f();
   CONSOLE_ClearIntermissionData_f();
   CONSOLE_BeginLevel_f();
   if (cls.key_dest == key_console)
      {
      Con_ToggleConsole_f();
      }
#endif
   }

/*
=================
CL_Begin_f

Sends a begin command to the server
=================
*/
void CL_Begin_f (void)
   {
 	MSG_WriteByte (&cls.netchan.message, clc_stringcmd);
   MSG_WriteString (&cls.netchan.message, va("begin %i\n", precache_spawncount ) );
   }
  
#endif

/*
=================
CL_InitLocal
=================
*/
static void CL_InitLocal (void)
{
#ifdef SIN
   int  i;
#endif
   cls.state = ca_disconnected;
	cls.realtime = Sys_Milliseconds ();

	CL_InitInput ();

	adr0 = Cvar_Get( "adr0", "", CVAR_ARCHIVE );
	adr1 = Cvar_Get( "adr1", "", CVAR_ARCHIVE );
	adr2 = Cvar_Get( "adr2", "", CVAR_ARCHIVE );
	adr3 = Cvar_Get( "adr3", "", CVAR_ARCHIVE );
	adr4 = Cvar_Get( "adr4", "", CVAR_ARCHIVE );
	adr5 = Cvar_Get( "adr5", "", CVAR_ARCHIVE );
	adr6 = Cvar_Get( "adr6", "", CVAR_ARCHIVE );
	adr7 = Cvar_Get( "adr7", "", CVAR_ARCHIVE );
   adr8 = Cvar_Get( "adr8", "", CVAR_ARCHIVE );

//
// register our variables
//
	cl_stereo_separation = Cvar_Get( "cl_stereo_separation", "0.4", CVAR_ARCHIVE );
	cl_stereo = Cvar_Get( "cl_stereo", "0", 0 );

#ifdef SIN
	cl_add_blend = Cvar_Get ("cl_blend", "1", CVAR_ARCHIVE);
	cl_add_lights = Cvar_Get ("cl_lights", "1", CVAR_ARCHIVE);
	cl_add_particles = Cvar_Get ("cl_particles", "1", CVAR_ARCHIVE);
   cl_add_bulletholes = Cvar_Get ("cl_bulletholes", "1", CVAR_ARCHIVE);
   cl_add_glows = Cvar_Get ("cl_glows", "1", CVAR_ARCHIVE);
#else
	cl_add_blend = Cvar_Get ("cl_blend", "1", 0);
	cl_add_lights = Cvar_Get ("cl_lights", "1", 0);
	cl_add_particles = Cvar_Get ("cl_particles", "1", 0);
#endif
	cl_add_entities = Cvar_Get ("cl_entities", "1", 0);
	cl_gun = Cvar_Get ("cl_gun", "1", 0);
	cl_footsteps = Cvar_Get ("cl_footsteps", "1", 0);
	cl_noskins = Cvar_Get ("cl_noskins", "0", 0);
	cl_autoskins = Cvar_Get ("cl_autoskins", "0", 0);
	cl_predict = Cvar_Get ("cl_predict", "1", 0);
#ifdef SIN
	cl_maxfps = Cvar_Get ("cl_maxfps", "1000", CVAR_ARCHIVE);	
#else
	cl_maxfps = Cvar_Get ("cl_maxfps", "1000", 0);	
#endif

	cl_upspeed = Cvar_Get ("cl_upspeed", "200", 0);
	cl_forwardspeed = Cvar_Get ("cl_forwardspeed", "200", 0);
#ifdef SIN
	cl_sidespeed = Cvar_Get ("cl_sidespeed", "320", 0);
   cl_add_triangles = Cvar_Get ("cl_tessellation", "1", CVAR_ARCHIVE);
   cl_add_detailmodels = Cvar_Get ("cl_detailmodels", "1", CVAR_ARCHIVE);
#else
	cl_sidespeed = Cvar_Get ("cl_sidespeed", "200", 0);
#endif
	cl_yawspeed = Cvar_Get ("cl_yawspeed", "140", 0);
	cl_pitchspeed = Cvar_Get ("cl_pitchspeed", "150", 0);
	cl_anglespeedkey = Cvar_Get ("cl_anglespeedkey", "1.5", 0);

	cl_run = Cvar_Get ("cl_run", "0", CVAR_ARCHIVE);
	freelook = Cvar_Get( "freelook", "0", CVAR_ARCHIVE );
	lookspring = Cvar_Get ("lookspring", "0", CVAR_ARCHIVE);
	lookstrafe = Cvar_Get ("lookstrafe", "0", CVAR_ARCHIVE);
	sensitivity = Cvar_Get ("sensitivity", "3", CVAR_ARCHIVE);
#ifdef SIN
   zoomscale = Cvar_Get ("zoomscale", ".1111", 0);
#endif
	m_pitch = Cvar_Get ("m_pitch", "0.022", CVAR_ARCHIVE);
	m_yaw = Cvar_Get ("m_yaw", "0.022", 0);
	m_forward = Cvar_Get ("m_forward", "1", 0);
	m_side = Cvar_Get ("m_side", "1", 0);

	cl_shownet = Cvar_Get ("cl_shownet", "0", 0);
	cl_showmiss = Cvar_Get ("cl_showmiss", "0", 0);
	cl_showclamp = Cvar_Get ("showclamp", "0", 0);
   cl_timeout = Cvar_Get ("cl_timeout", "120", 0);
   cl_paused = Cvar_Get ("paused", "0", 0);
	cl_timedemo = Cvar_Get ("timedemo", "0", 0);

	rcon_client_password = Cvar_Get ("rcon_password", "", 0);
	rcon_address = Cvar_Get ("rcon_address", "", 0);

	cl_lightlevel = Cvar_Get ("r_lightlevel", "0", 0);

	//
	// userinfo
	//
	info_password = Cvar_Get ("password", "", CVAR_USERINFO);
	name = Cvar_Get ("name", "unnamed", CVAR_USERINFO | CVAR_ARCHIVE);
#ifdef SIN
   skin  = Cvar_Get ("skin", "blade_base", CVAR_USERINFO | CVAR_ARCHIVE );
	model = Cvar_Get ("model", "pl_blade", CVAR_USERINFO | CVAR_ARCHIVE);
	bikeskin  = Cvar_Get ("bikeskin", "hover_02a_r", CVAR_USERINFO | CVAR_ARCHIVE );
	bikemodel = Cvar_Get ("bikemodel", "bike_prototype", CVAR_USERINFO | CVAR_ARCHIVE);

	// allows player to turn off auto weapon switching
	Cvar_Get ("weaponswitch", "1", CVAR_USERINFO | CVAR_ARCHIVE);

	// allow turning off of weapon selection overriding
	Cvar_Get ("weaponoverride", "1", CVAR_USERINFO | CVAR_ARCHIVE);

//***
	dt0 = Cvar_Get("dt0", "0", 0);
	dt1 = Cvar_Get("dt1", "0", 0);
	dt2 = Cvar_Get("dt2", "0", 0);
	dt3 = Cvar_Get("dt3", "0", 0);
	dt4 = Cvar_Get("dt4", "0", 0);
	dt5 = Cvar_Get("dt5", "0", 0);
	dtprint = Cvar_Get("dtprint", "0", 0);
//***
#else
   skin = Cvar_Get ("skin", "male/grunt", CVAR_USERINFO | CVAR_ARCHIVE);
#endif
#ifdef SIN
	rate = Cvar_Get ("rate", "5000", CVAR_USERINFO | CVAR_ARCHIVE);	// FIXME
#else
	rate = Cvar_Get ("rate", "25000", CVAR_USERINFO | CVAR_ARCHIVE);	// FIXME
#endif
	msg = Cvar_Get ("msg", "1", CVAR_USERINFO | CVAR_ARCHIVE);
	hand = Cvar_Get ("hand", "0", CVAR_USERINFO | CVAR_ARCHIVE);
#ifdef SIN
	if ( hand->value < 0 || hand->value > 2 )
		Cvar_SetValue( "hand", 0 );

   Cvar_Get ("fov", "90", CVAR_USERINFO | CVAR_ARCHIVE);
   cl_oldnoclip = Cvar_Get ("cl_oldnoclip", "0", CVAR_USERINFO | CVAR_ARCHIVE);
   cl_oldladders = Cvar_Get ("cl_oldladders", "0", CVAR_USERINFO | CVAR_ARCHIVE);
   cl_dumpdemo = Cvar_Get ("dumpdemo", "0", 0);
   cl_document = Cvar_Get ("document", "0", 0);
   cl_demoplaying = Cvar_Get ("demoplaying", "0", 0);
   precache = Cvar_Get("cl_precache", "1" , 0);
   cl_forcecinematic = Cvar_Get("cl_forcecinematic", "1" , CVAR_ARCHIVE);

   cl_nospeech = Cvar_Get("cl_nospeech", "0" , CVAR_ARCHIVE);
   cl_speechdelay = Cvar_Get("cl_speechdelay", "1000" , CVAR_ARCHIVE);
#endif
	//
	// register our commands
	//
	Cmd_AddCommand ("cmd", CL_ForwardToServer_f);
	Cmd_AddCommand ("pause", CL_Pause_f);
	Cmd_AddCommand ("pingservers", CL_PingServers_f);
	Cmd_AddCommand ("skins", CL_Skins_f);

	Cmd_AddCommand ("userinfo", CL_Userinfo_f);
	Cmd_AddCommand ("snd_restart", CL_Snd_Restart_f);

	Cmd_AddCommand ("changing", CL_Changing_f);
	Cmd_AddCommand ("disconnect", CL_Disconnect_f);
	Cmd_AddCommand ("record", CL_Record_f);
	Cmd_AddCommand ("stop", CL_Stop_f);

	Cmd_AddCommand ("quit", CL_Quit_f);

	Cmd_AddCommand ("connect", CL_Connect_f);
	Cmd_AddCommand ("reconnect", CL_Reconnect_f);

	Cmd_AddCommand ("rcon", CL_Rcon_f);
//    Cmd_AddCommand ("packet", CL_Packet_f); // this is dangerous to leave in

//	Cmd_AddCommand ("setenv", CL_Setenv_f );

	Cmd_AddCommand ("precache", CL_Precache_f);

   Cmd_AddCommand ("download", CL_Download_f);

#ifdef SIN_ARCADE
	Cmd_AddCommand ("playerdead", CL_Arcade_PlayerDead_f);
   Cmd_AddCommand ("gameover", CL_Arcade_GameOver_f);
   Cmd_AddCommand ("arcade_putbyte", CL_Arcade_PutByte_f );
   Cmd_AddCommand ("checkfirst", CL_Arcade_CheckFirst_f );
#endif


#ifdef SIN
   Cmd_AddCommand ("rem", CL_Remark_f);
   Cmd_AddCommand ("printcommands", CL_PrintDefCommands);
   Cmd_AddCommand ("definfo", CL_DefInfo);
   Cmd_AddCommand ("precache_done", CL_PrecacheDone_f );
   Cmd_AddCommand ("loadmap", CL_PreLoadMap_f );
   Cmd_AddCommand ("cl_begin", CL_Begin_f );
#endif
	//
	// forward to server commands
	//
	Cmd_AddCommand ("wave", NULL);
	Cmd_AddCommand ("inven", NULL);
	Cmd_AddCommand ("kill", NULL);
	Cmd_AddCommand ("use", NULL);
	Cmd_AddCommand ("drop", NULL);
	Cmd_AddCommand ("say", NULL);
	Cmd_AddCommand ("say_team", NULL);
	Cmd_AddCommand ("info", NULL);
	Cmd_AddCommand ("prog", NULL);
#ifndef SIN
	Cmd_AddCommand ("give", NULL);
	Cmd_AddCommand ("god", NULL);
	Cmd_AddCommand ("notarget", NULL);
	Cmd_AddCommand ("noclip", NULL);
	Cmd_AddCommand ("fov", NULL);
	Cmd_AddCommand ("say_talk", NULL);
#endif
	Cmd_AddCommand ("invuse", NULL);
	Cmd_AddCommand ("invprev", NULL);
	Cmd_AddCommand ("invnext", NULL);
	Cmd_AddCommand ("invdrop", NULL);
	Cmd_AddCommand ("weapnext", NULL);
	Cmd_AddCommand ("weapprev", NULL);
	Cmd_AddCommand ("gameversion", NULL);
#ifdef SIN
	Cmd_AddCommand ("viewspawn", NULL);
	Cmd_AddCommand ("viewmodel", NULL);
	Cmd_AddCommand ("viewnext", NULL);
	Cmd_AddCommand ("viewprev", NULL);
	Cmd_AddCommand ("viewnextanim", NULL);
	Cmd_AddCommand ("viewprevanim", NULL);
	Cmd_AddCommand ("viewanimate", NULL);
	Cmd_AddCommand ("viewscaleup", NULL);
	Cmd_AddCommand ("viewscaledown", NULL);
	Cmd_AddCommand ("viewscale", NULL);
	Cmd_AddCommand ("viewyaw", NULL);
	Cmd_AddCommand ("viewthingnext", NULL);
	Cmd_AddCommand ("viewthingprev", NULL);
	Cmd_AddCommand ("viewattach", NULL);
	Cmd_AddCommand ("viewdetach", NULL);
	Cmd_AddCommand ("viewdelete", NULL);
	Cmd_AddCommand ("viewdetachall", NULL);
	Cmd_AddCommand ("viewbonegroup", NULL);
	Cmd_AddCommand ("viewbonenum", NULL);
	Cmd_AddCommand ("viewboneangles", NULL);
	Cmd_AddCommand ("vieworigin", NULL);
	Cmd_AddCommand ("viewnextskin", NULL);
	Cmd_AddCommand ("viewprevskin", NULL);
	Cmd_AddCommand ("viewautoanimate", NULL);
// added spritegun commands
	Cmd_AddCommand ("spg_save", NULL);
	Cmd_AddCommand ("spg_load", NULL);
	Cmd_AddCommand ("spg_file", NULL);
	Cmd_AddCommand ("spg_glow", NULL);
	Cmd_AddCommand ("spg_hitwater", NULL);
	Cmd_AddCommand ("spg_next", NULL);
	Cmd_AddCommand ("spg_previous", NULL);
	Cmd_AddCommand ("spg_delete", NULL);
	Cmd_AddCommand ("spg_scale", NULL);
	Cmd_AddCommand ("spg_alpha", NULL);
	Cmd_AddCommand ("spg_frame", NULL);
	Cmd_AddCommand ("spg_nextframe", NULL);
	Cmd_AddCommand ("spg_prevframe", NULL);
	Cmd_AddCommand ("spg_movesize", NULL);
	Cmd_AddCommand ("spg_moveright", NULL);
	Cmd_AddCommand ("spg_moveleft", NULL);
	Cmd_AddCommand ("spg_moveup", NULL);
	Cmd_AddCommand ("spg_movedown", NULL);
	Cmd_AddCommand ("spg_moveforward", NULL);
	Cmd_AddCommand ("spg_moveback", NULL);
	Cmd_AddCommand ("spg_setpitch", NULL);
	Cmd_AddCommand ("spg_setyaw", NULL);
	Cmd_AddCommand ("spg_setroll", NULL);
	Cmd_AddCommand ("spg_rotsize", NULL);
	Cmd_AddCommand ("spg_pitchup", NULL);
	Cmd_AddCommand ("spg_pitchdown", NULL);
	Cmd_AddCommand ("spg_yawright", NULL);
	Cmd_AddCommand ("spg_yawleft", NULL);
	Cmd_AddCommand ("spg_rollright", NULL);
	Cmd_AddCommand ("spg_rollleft", NULL);
	Cmd_AddCommand ("spg_get", NULL);
	Cmd_AddCommand ("spg_give", NULL);
	Cmd_AddCommand ("spg_clear", NULL);
	Cmd_AddCommand ("spg_flip", NULL);
	Cmd_AddCommand ("spg_animspeed", NULL);
	Cmd_AddCommand ("spg_animdelay", NULL);
	Cmd_AddCommand ("spg_pitchspeed", NULL);
	Cmd_AddCommand ("spg_yawspeed", NULL);
	Cmd_AddCommand ("spg_rollspeed", NULL);
	Cmd_AddCommand ("spg_rotdelay", NULL);
	Cmd_AddCommand ("spg_blinkspeed", NULL);
	Cmd_AddCommand ("spg_blinkdelay", NULL);
	Cmd_AddCommand ("spg_targetname", NULL);
	Cmd_AddCommand ("spg_triggereffect", NULL);
	
	Cmd_AddCommand ("consolecmd", NULL);
	Cmd_AddCommand ("consolevar", NULL);
	Cmd_AddCommand ("consolepos", NULL);
	Cmd_AddCommand ("consoleneg", NULL);
	Cmd_AddCommand ("consoleret", NULL);
	Cmd_AddCommand ("consolemenu", NULL);
	Cmd_AddCommand ("exitcon", NULL);
	Cmd_AddCommand ("deflist", SINMDL_ModelList);
	Cmd_AddCommand ("aliasdump", Alias_Dump);
	Cmd_AddCommand ("weaponuse", NULL);
	Cmd_AddCommand ("taunt", NULL);
	// process the global defs  
	for ( i = 0; i < 10; i++ ) {
		CL_CMDS_ProcessFile( va( "global/global%i.scr", i ) );
	}
	CL_ResetMusic();
#endif
}


/*
===============
CL_WriteConfiguration

Writes key bindings and archived cvars to config.cfg
===============
*/
void CL_WriteConfiguration (void)
{
	FILE	*f;
	char	path[MAX_QPATH];

	if (cls.state == ca_uninitialized)
		return;

#ifdef SIN
	Com_sprintf (path, sizeof(path),"%s/config.cfg",FS_Playerdir());
#else
	Com_sprintf (path, sizeof(path),"%s/config.cfg",FS_Gamedir());
#endif
	f = QuakeOpenAFile (path, "w");
	if (!f)
	{
		Com_Printf ("Couldn't write config.cfg.\n");
		return;
	}

#ifdef SIN
	fprintf (f, "rem generated by Sin, do not modify\n");
#else
	fprintf (f, "; generated by quake, do not modify\n");
#endif
	Key_WriteBindings (f);
	fclose (f);

	Cvar_WriteVariables (path);
}

/*
==================
CL_FixCvarCheats

==================
*/

typedef struct
{
	char	*name;
	char	*value;
	cvar_t	*var;
} cheatvar_t;

cheatvar_t	cheatvars[] = {
	{"timescale", "1"},
	{"timedemo", "0"},
	{"r_drawworld", "1"},
	{"cl_testlights", "0"},
	{"r_draworder", "0"},
	{"r_fullbright", "0"},
	{"r_drawflat", "0"},
	{"paused", "0"},
	{"fixedtime", "0"},
	{"gl_showtris", "0"},
	{"gl_lightmap", "0"},
	{"gl_saturatelighting", "0"},
	{NULL, NULL}
};

int		numcheatvars;

static void CL_FixCvarCheats (void)
{
	int			i;
	cheatvar_t	*var;

	if ( !strcmp(cl.configstrings[CS_MAXCLIENTS], "1")
		|| !cl.configstrings[CS_MAXCLIENTS][0] )
		return;		// single player can cheat

	// find all the cvars if we haven't done it yet
	if (!numcheatvars)
	{
		while (cheatvars[numcheatvars].name)
		{
			cheatvars[numcheatvars].var = Cvar_Get (cheatvars[numcheatvars].name,
					cheatvars[numcheatvars].value, 0);
			numcheatvars++;
		}
	}

	// make sure they are all set to the proper values
	for (i=0, var = cheatvars ; i<numcheatvars ; i++, var++)
	{
		if ( strcmp (var->var->CVarString, var->value) )
		{
			Cvar_Set (var->name, var->value);
		}
	}
}

//============================================================================

/*
==================
CL_SendCommand

==================
*/
static void CL_SendCommand (void)
{
	// get new key events
	Sys_SendKeyEvents ();

	// allow mice or other external controllers to add commands
	IN_Commands ();

	// process console commands
	Cbuf_Execute ();

	// fix any cheating cvars
	CL_FixCvarCheats ();

	// send intentions now
	CL_SendCmd ();

	// resend a connection request if necessary
	CL_CheckForResend ();
}


/*
==================
CL_Frame

==================
*/
void CL_Frame (int msec)
{
	static int	extratime;
	static int  lasttimecalled;

	if (dedicated->value)
		return;

	extratime += msec;
	if (!cl_timedemo->value) {
		if (cls.state == ca_connected && extratime < 100) {
			return;			// don't flood packets out while connecting
		}
		if (extratime < 1000/cl_maxfps->value) {
			return;			// framerate is too high
		}
	}

	// let the mouse activate or deactivate
	IN_Frame ();

	// decide the simulation time
	cls.frametime = extratime/1000.0;
	cl.time += extratime;
	cls.realtime = curtime;

	extratime = 0;
	if (cls.frametime > (1.0 / 5))
		cls.frametime = (1.0 / 5);

	// if in the debugger last frame, don't timeout
	if (msec > 5000)
		cls.netchan.last_received = Sys_Milliseconds ();

	// fetch results from server
	CL_ReadPackets ();

	// send a new command message to the server
	CL_SendCommand ();

	// predict all unacknowledged movements
	CL_PredictMovement ();

#ifdef SIN
   // To the surface thing
   CL_ProcessSurfaces ();
#endif

	// allow rendering DLL change
	VID_CheckChanges ();
	if (!cl.refresh_prepped && cls.state == ca_active)
      {
#ifdef SIN
      CL_CalculateLoadBar();
#endif
		CL_PrepRefresh ();
      }

	// update the screen
	if (host_speeds->value || fps->value)
		time_before_ref = Sys_Milliseconds ();
	SCR_UpdateScreen ();
	if (host_speeds->value || fps->value)
		time_after_ref = Sys_Milliseconds ();

	// update audio
	S_Update (cl.refdef.vieworg, cl.v_forward, cl.v_right, cl.v_up);

	CDAudio_Update();

	// advance local effects for next frame
#ifndef SIN
	CL_RunDLights ();
	CL_RunLightStyles ();
	SCR_RunCinematic ();
	SCR_RunConsole ();
#else
	CL_ServerListThink();
	SCR_RunCinematic ();
	SCR_RunConsole ();
#endif

	cls.framecount++;

	if ( log_stats->value )
	{
		if ( cls.state == ca_active )
		{
			if ( !lasttimecalled )
			{
				lasttimecalled = Sys_Milliseconds();
				if ( log_stats_file )
					fprintf( log_stats_file, "0\n" );
			}
			else
			{
				int now = Sys_Milliseconds();

				if ( log_stats_file )
					fprintf( log_stats_file, "%d\n", now - lasttimecalled );
				lasttimecalled = now;
			}
		}
	}
#ifdef SIN
   if ( cl_document->value )
      {
      static int lasttime=-1;
      int inttime;

      inttime = cls.realtime / (cl_document->value*1000);
      if ( inttime != lasttime)
         {
         lasttime = inttime;
         Cbuf_AddText("screenshot" );
         }
      }
	if (cl_dumpdemo->value && cl_demoplaying->value)
      {
      Cbuf_AddText ( "screenshot" );
      }
   CL_UpdateMusic();
#endif

}


//============================================================================

/*
====================
CL_Init
====================
*/
void CL_Init (void)
{
	if (dedicated->value)
		return;		// nothing running on the client

	// all archived variables will now be loaded

	Con_Init ();

#ifdef SIN_ARCADE
   ARCADE_SetupCommunications();
#endif

#if defined __linux__ || defined __sgi
	S_Init ();
	VID_Init ();
#else
	VID_Init ();
	S_Init ();	// sound must be initialized after window is created
#endif

	V_Init ();

	net_message.data = net_message_buffer;
	net_message.maxsize = sizeof(net_message_buffer);


#ifndef SIN  
	M_Init ();
#endif

	SCR_Init ();
	
#ifndef SIN
	cls.disable_screen = TRUE;	// don't draw yet
#endif

	CDAudio_Init ();
	CL_InitLocal ();
#ifdef SIN
	CON_Init();
#endif
	IN_Init ();
	FS_ExecAutoexec ();
	Cbuf_Execute ();
}


/*
===============
CL_Shutdown

FIXME: this is a callback from Sys_Quit and Com_Error.  It would be better
to run quit through here before the final handoff to the sys code.
===============
*/
void CL_Shutdown(void)
{
	static qboolean isdown = FALSE;

	if (isdown)	{
		DebugString("recursive shutdown\n");
		return;
	}
	isdown = TRUE;

	CL_WriteConfiguration ();

	CDAudio_Shutdown ();
	S_Shutdown();
	IN_Shutdown ();
	VID_Shutdown();

#ifdef SIN_ARCADE
   ARCADE_CloseCommunications();
#endif
}

