//-----------------------------------------------------------------------------
//
//  $Logfile:: /Source/crc.h                                                  $
// $Revision:: 2                                                              $
//   $Author:: Burgermac                                                      $
//     $Date:: 12/27/00 5:13 PM                                               $
//
// Copyright (C) 1998 by Ritual Entertainment, Inc.
// All rights reserved.
//
// This source is may not be distributed and/or modified without
// expressly written permission by Ritual Entertainment, Inc.
//
// DESCRIPTION:
// This is a 16 bit, non-reflected CRC using the polynomial 0x1021
// and the initial and final xor values shown below...  in other words, the
// CCITT standard CRC used by XMODEM.
//

#ifndef __CRC_H__
#define __CRC_H__

extern void CRC_Init(unsigned short *crcvalue);
extern void CRC_ProcessByte(unsigned short *crcvalue, unsigned char data);
extern unsigned short CRC_Value(unsigned short crcvalue);
extern unsigned short CRC_Block (const unsigned char *start, int count);

#endif