//-----------------------------------------------------------------------------
//
// Copyright (C) 1998 by Ritual Entertainment, Inc.
// All rights reserved.
//
// This source is may not be distributed and/or modified without
// expressly written permission by Ritual Entertainment, Inc.
//
// DESCRIPTION:
// 

#ifndef __SCREEN_H__
#define __SCREEN_H__

#ifndef __VID_H__
#include "vid.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

void	SCR_Init (void);

void	SCR_UpdateScreen (void);

void	SCR_SizeUp (void);
void	SCR_SizeDown (void);
#ifdef SIN
void	SCR_CenterPrint (const char *str);
#else
void	SCR_CenterPrint (char *str);
#endif
void	SCR_BeginLoadingPlaque (void);
void	SCR_EndLoadingPlaque (void);

void	SCR_DebugGraph (float value, int color);

void	SCR_TouchPics (void);

void	SCR_RunConsole (void);

extern	float		scr_con_current;
extern	float		scr_conlines;		// lines of console to display

extern	int			sb_lines;

extern	cvar_t		*scr_viewsize;
extern	cvar_t		*crosshair;

extern vrect_t scr_vrect;		// position of render window

extern	char		crosshair_pic[MAX_QPATH];
extern	int			crosshair_width, crosshair_height;

#ifdef SIN
extern   char		zoom_crosshair_pic[MAX_QPATH];
extern   int		zoom_crosshair_width, zoom_crosshair_height;
#endif

void SCR_AddDirtyPoint (int x, int y);
void SCR_DirtyScreen (void);

//
// scr_cin.c
//
#ifdef SIN
void SCR_PlayCinematic( const char *name );
#else
void SCR_PlayCinematic (char *name);
#endif
qboolean SCR_DrawCinematic (void);
void SCR_RunCinematic (void);
void SCR_StopCinematic (void);
void SCR_FinishCinematic (void);

#ifdef __cplusplus
}
#endif

#endif